# Copyright 2023 The Dawn & Tint Authors
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# 1. Redistributions of source code must retain the above copyright notice, this
#    list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above copyright notice,
#    this list of conditions and the following disclaimer in the documentation
#    and/or other materials provided with the distribution.
#
# 3. Neither the name of the copyright holder nor the names of its
#    contributors may be used to endorse or promote products derived from
#    this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

################################################################################
# File generated by 'tools/src/cmd/gen' using the template:
#   tools/src/cmd/gen/build/BUILD.cmake.tmpl
#
# To regenerate run: './tools/run gen'
#
#                       Do not modify this file directly
################################################################################

if(TINT_BUILD_SPV_WRITER)
################################################################################
# Target:    tint_lang_spirv_writer_raise
# Kind:      lib
# Condition: TINT_BUILD_SPV_WRITER
################################################################################
tint_add_target(tint_lang_spirv_writer_raise lib
  lang/spirv/writer/raise/builtin_polyfill.cc
  lang/spirv/writer/raise/builtin_polyfill.h
  lang/spirv/writer/raise/expand_implicit_splats.cc
  lang/spirv/writer/raise/expand_implicit_splats.h
  lang/spirv/writer/raise/handle_matrix_arithmetic.cc
  lang/spirv/writer/raise/handle_matrix_arithmetic.h
  lang/spirv/writer/raise/merge_return.cc
  lang/spirv/writer/raise/merge_return.h
  lang/spirv/writer/raise/pass_matrix_by_pointer.cc
  lang/spirv/writer/raise/pass_matrix_by_pointer.h
  lang/spirv/writer/raise/raise.cc
  lang/spirv/writer/raise/raise.h
  lang/spirv/writer/raise/remove_unreachable_in_loop_continuing.cc
  lang/spirv/writer/raise/remove_unreachable_in_loop_continuing.h
  lang/spirv/writer/raise/shader_io.cc
  lang/spirv/writer/raise/shader_io.h
  lang/spirv/writer/raise/var_for_dynamic_index.cc
  lang/spirv/writer/raise/var_for_dynamic_index.h
)

tint_target_add_dependencies(tint_lang_spirv_writer_raise lib
  tint_api_common
  tint_lang_core
  tint_lang_core_common
  tint_lang_core_constant
  tint_lang_core_intrinsic
  tint_lang_core_ir
  tint_lang_core_ir_transform
  tint_lang_core_type
  tint_lang_spirv
  tint_lang_spirv_intrinsic
  tint_lang_spirv_ir
  tint_lang_spirv_type
  tint_utils
  tint_utils_containers
  tint_utils_diagnostic
  tint_utils_ice
  tint_utils_macros
  tint_utils_math
  tint_utils_memory
  tint_utils_result
  tint_utils_rtti
  tint_utils_symbol
  tint_utils_text
)

tint_target_add_external_dependencies(tint_lang_spirv_writer_raise lib
  "src_utils"
)

if(TINT_BUILD_SPV_READER OR TINT_BUILD_SPV_WRITER)
  tint_target_add_external_dependencies(tint_lang_spirv_writer_raise lib
    "spirv-headers"
  )
endif(TINT_BUILD_SPV_READER OR TINT_BUILD_SPV_WRITER)

if(TINT_BUILD_SPV_WRITER)
  tint_target_add_dependencies(tint_lang_spirv_writer_raise lib
    tint_lang_spirv_writer_common
  )
endif(TINT_BUILD_SPV_WRITER)

endif(TINT_BUILD_SPV_WRITER)
if(TINT_BUILD_SPV_WRITER)
################################################################################
# Target:    tint_lang_spirv_writer_raise_test
# Kind:      test
# Condition: TINT_BUILD_SPV_WRITER
################################################################################
tint_add_target(tint_lang_spirv_writer_raise_test test
  lang/spirv/writer/raise/builtin_polyfill_test.cc
  lang/spirv/writer/raise/expand_implicit_splats_test.cc
  lang/spirv/writer/raise/handle_matrix_arithmetic_test.cc
  lang/spirv/writer/raise/merge_return_test.cc
  lang/spirv/writer/raise/pass_matrix_by_pointer_test.cc
  lang/spirv/writer/raise/remove_unreachable_in_loop_continuing_test.cc
  lang/spirv/writer/raise/shader_io_test.cc
  lang/spirv/writer/raise/var_for_dynamic_index_test.cc
)

tint_target_add_dependencies(tint_lang_spirv_writer_raise_test test
  tint_api_common
  tint_lang_core
  tint_lang_core_constant
  tint_lang_core_intrinsic
  tint_lang_core_ir
  tint_lang_core_ir_transform_test
  tint_lang_core_type
  tint_utils
  tint_utils_containers
  tint_utils_diagnostic
  tint_utils_ice
  tint_utils_macros
  tint_utils_math
  tint_utils_memory
  tint_utils_result
  tint_utils_rtti
  tint_utils_symbol
  tint_utils_text
)

tint_target_add_external_dependencies(tint_lang_spirv_writer_raise_test test
  "gtest"
  "src_utils"
)

if(TINT_BUILD_SPV_WRITER)
  tint_target_add_dependencies(tint_lang_spirv_writer_raise_test test
    tint_lang_spirv_writer_raise
  )
endif(TINT_BUILD_SPV_WRITER)

endif(TINT_BUILD_SPV_WRITER)